Rem * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'
' Stupnice - ta ke krtkovlnnmu TRXU, zaloen na jednoipu
' Atmel AVR typu AtMega48.
' Krystal: 22.1184 Mhz
' Vyuv "inteligentn displej" 2 krt 8 znak.
' Monost nastaven MF kmitotu (+ nebo - podle toho, zda je kmitoet osciltoru
' nad, nebo pod MF kmitotem.
' Monost men napjecho napt
' Monost zapnut podsvtlen displeje tlatkem
'
Rem * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *



$regfile = "m48def.dat"                                     'definin soubor pro peklad pro ip AtMega 48
$crystal = 22118400                                         'krystal 22.1184 Mhz


Rem deklarace promennch

Dim Volt1 As Word                                           'promnn pro uloen hodnoty z A/D pevodu
Dim Volt2 As Single                                         'promnn pro vpoet napt z A/D pevodu
Dim Volt As String * 8                                      'promnn pro zobrazen napt

Dim P As Byte                                               ' pridanch 8 bit ke Counteru1 (zvysuje se o 1 pri preteceni)
Dim K As Byte                                               ' kolikrat doslo k preteceni behem jednoho mereni (0,1 sekundy)
Dim X As Word                                               ' okamit hodnota Counteru1 po skonen hradlovn
Dim A As Word                                               ' ta setin sekundy (mus probhnout desetkrt pro hradlovn)
Dim Frq As Long                                             ' pomocn promnn pro vpoet kmitotu
Dim F As String * 8                                         ' pomocn promnn pro zobrazen kmitotu
Dim Mf As Eram Long                                         ' Hodnota Mezifrekvence Uloen V Eeprom
Dim Mff As Long                                             ' pomocn promnn pi nastavovn mezifrekvence
Dim Mfk As String * 8

Dim Cas As Byte                                             'promnn pro men asu pi dren tlatka


Rem konfigurace vstupnch pin pro LCD displej podle toho, jak vyel plon spoj
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portd.6 , Db5 = Portb.4 , Db6 = Portb.0 , Db7 = Portd.7 , E = Portb.2 , Rs = Portb.3

Rem konfigurace ta a asova
Config Timer0 = Timer , Prescale = 1024                     'peddlika 1024 pro 8mi bitov Timer0
Config Timer1 = Counter , Prescale = 1 , Edge = Falling , Noise Cancel = 1       ' nastaven Timer1 jako ta
Config Timer2 = Timer , Prescale = 1024                     'asova/timer2 pro men asu stisknut tlatka


Rem nastaven vstupnch/vstupnch pin
Set Portc.6                                                 'nastaven pinu C.6 na 1 (zapojen pull-up rezistoru na vstup RESET). Nen poteba vnj rezistor

Config Pind.0 = Output                                      'vstupn pin pro ovldn LED podsvtlen.(pes odpor spn tranzistor)
Reset Portd.0                                               'nastaven na "zhasnuto" pi zapnut

Config Pind.2 = Input                                       'ovldac pin pro podsvtlen (ext.peruen INT0)(Tlatko - svtlo)
Set Portd.2                                                 'zapojen pull-up rezistoru

Config Pind.1 = Input                                       'ovldac pin pro men napt(v podprogramu "Tlacitko:" se testuje krtk a dlouh stisk)
Set Portd.1                                                 'zapojen pull-up rezistoru

Config Pinc.5 = Input                                       'ovldac pin pro "Nastav MF"
Set Portc.5
Config Pinc.4 = Input                                       'ovldac pin pro zven MF o 1 kHz
Set Portc.4
Config Pinc.3 = Input                                       'ovldac pin pro snen MF o 1 kHz
Set Portc.3
Config Pinc.2 = Input                                       'uloen nastaven hodnoty MF a nvrat k men kmitotu
Set Portc.2
Config Pind.3 = Input                                       'ovldac pin pro zven MF o 10 Hz
Set Portd.3
Config Pind.4 = Input                                       'ovldac pin pro snen MF o 10 Hz
Set Portd.4



Rem konfigurace AD pevodnku
Config Adc = Single , Prescaler = Auto                      'nastaven ADC pevodnku


Rem povolen asovae Timer0, povolen peruen obecn, povolen peruen Overflow0 a Overflow1
Enable Timer0
Enable Interrupts
Enable Ovf0
Enable Ovf1

Enable Int0                                                 'povolen externho peruen INT0
Config Int0 = Low Level                                     'peruen pi uzemnn vstupu

Start Timer0                                                ' Spusteni casovace Timer0


On Ovf0 Pridej0                                             ' pi peruen od peteen  asovae 0 odskok do podprogramu (celkem 10x za jedno men)
On Ovf1 Pridej1                                             ' pi peruen od peteen tae 1 odskok do podprogramu (pidv poslednch 8 bit tae)
On Int0 Svetlo                                              'pi externm peruen INT0 odskok na rozsvcen (zhasnut) svtla



Cls                                                         'smazn displeje a vypnut kurzoru
Cursor Off

Deflcdchar 1 , 10 , 4 , 31 , 2 , 4 , 8 , 31 , 32            'definice znaku s diakritikou  "" (pro zobrazen slova uloeno)

Rem ***********************************************************************************************************
Rem hlavn smyka vpotu a zobrazovn kmitotu

Do
    Locate 1 , 1
    Lcd "        "
    Locate 1 , 1
    Frq = K * 65536                                         'Vpoet kmitotu
    Frq = Frq + X
    Frq = Frq + Mf                                          'Piten MF
    Frq = Abs(frq)
    F = Str(frq)                                            'Formtovn vsledku pro zobrazen
    F = Left(f , 7)
    F = Format(f , " 0000.00")
    Lcd F                                                   'Zobrazen
    Waitms 50                                               'ekn 50 milisekund


Rem podmnky pro odskoky z hlavn smyky


    Debounce Pinc.5 , 0 , Nastav_mf , Sub                   'tlatko pro odskok do nastaven mezifrekvence

    Debounce Pind.1 , 0 , Tlacitko , Sub                    'tlatko pro odskok na men napt


    If Cas > 150 Then                                       'Pi dlouhm asu stisknut...
    Gosub Volty2                                            'skok nkam...
    Waitms 200
    Elseif Cas =< 150 Then                                  'pi krtkm asu stisknut, ...
    If Cas > 0 Then                                         '... ale ne nulovm...
    Gosub Volty                                             '.skok jinam.
    Waitms 200
    End If
    End If                                                  'konce vech podmnek
    Cas = 0                                                 'vynulovn promnn na men asu stisknut tlatka
Loop

Rem ***********************************************************************************************************

Rem * * * * * * * * * * * * *
Rem       podprogramy       *
Rem * * * * * * * * * * * * *

Rem Testovn asu stisknut tlatka pro odskok na men napt
Tlacitko:
   Waitms 20                                                'ekn 20 milisekund
   Do                                                       'zatek smyky
      Start Timer2                                          'zapnut asovae Timer2
      Enable Ovf2                                           'povolen peruen od peteen asovae Timer2
      On Ovf2 Drzim                                         'pi peteen odskok do podprogramu Drzim
      If Pind.1 = 1 Then                                    'pokud pustme tlatko  tak....
      Disable Ovf2                                          'zakzn peruen....
      Stop Timer2                                           'vypnut asovae.....
      Return                                                'nvrat do hlavn smyky men kmitotu
      Elseif Cas > 150 Then                                 'pokud je stle stisknuto tlatko a peruen probhlo vce ne 150krt....
      Disable Ovf2                                          'tak zakzn peruen....
      Stop Timer2                                           'vypnut asovae.....
      Cls                                                   'smazn displeje......
      Locate 1 , 1
      Lcd "Baterie:"                                        'zobrazen slova baterie (abychom vdli, e u mme pustit tlatko :-))
      Bitwait Pind.1 , Set                                  'a kdy tlatko konen pustme, tak...
      Return                                                '....nvrat do hlavn smyky (odkud hned zase odskome na men napt)
      End If                                                'konec podmnky
   Loop                                                     'konec smyky

Rem podprogram Drzim (sem se odskakuje, pokud dojde k peteen asovace Timer2)
Drzim:
Incr Cas                                                    'zven promnn Cas o jednu
Return                                                      'Nvrat do podprogramu tlacitko

Rem ************************************************************************************************************

Rem rozsvcen/zhasnut svtla
Svetlo:
    Toggle Portd.0                                          'zmna stavu portu D.0 (pes rezistor m pipojen spnac tranzistor)
    Waitms 500                                              'ekn 0,5 sekundy
    Return                                                  'nvrat tam, odkud bylo vyvolno extern peruen INT0

Rem ************************************************************************************************************

Rem podrogramy pro men kmitotu

Rem : sem odskok pi peteen asovae Timer0 kterm generujeme hradlovac signl 10Hz
Pridej0:                                                    'generovani hradlovaciho signalu 10Hz
Incr A                                                      'zven A o 1. Mus probhnout 10x abychom ze 100Hz dostali 10Hz
If A = 10 Then                                              'pokud probhlo zven 10krt....
Gosub Precti                                                'tak odskok na zjitn okamitho stavu tae Counter1....
A = 0                                                       'a vynulovn
End If                                                      'konec podmnky
Tcnt0 = 40                                                  'prednastaveni hodnoty Timeru0 tak, abychom po dlen dostali 100Hz (hodnota zvis na kmitotu krystalu)
Return

Rem * * * * *
Rem sem odskok pi peteen tae Counter1, kter jsme pidnm 8mi bit (promnn P typu Byte) doplnili z 16ti na 24bitov

Pridej1:                                                    'zven nejvyho Byte tae kmitotu (hornch 8 bit,...
                                                            '...pidanch k 16ti bitovmu tai Counter1, kter jsme tak doplnili na 24-bitov)
Incr P                                                      'Zven P o 1 (pi peteen tae Counter1)
Return                                                      'nvrat

Rem * * * * *
Rem zjitn a uloen okamitho stavu tae kmitotu (Counter1 a promnn P) kadch 1/10 sekundy (hradlovn 10Hz)

Precti:
X = Timer1                                                  'zjitn okamitho stavu tae Counter1,
K = P                                                       'uloen stavu nejvych 8mi bit tae kmitotu (kolikrt probhlo peteen)
Timer1 = 0                                                  'vynulovn...
P = 0                                                       '...obou hodnot pro monost dalho men.
Return                                                      'nvrat do hlavn smyky, kde z hodnot X a K vypotme a zobrazme kmitoet


Rem ***********************************************************************************************************

Rem jednorzov zmen napt a zobrazen na dobu 5 sekund

Volty:

      Start Adc                                             'zapnut A/D pevodnku
      Volt1 = Getadc(0)                                     'zjitn hodnoty z pevodnku ADC0 a uloen do promnn "Volt1"
      Stop Adc                                              'vypnut A/D pevodnku
      Volt2 = Volt1 * 0.02                                  'vpoet napt
      Volt = Str(volt2)                                     'zformtovn pro zobrazen
      Volt = Left(volt , 4)
      Locate 2 , 1
      Lcd "Ub=" ; Volt ; "V"                                'zobrazen zmen a vypotan hodnoty
      Wait 4                                                'ekn 4 sekundy
      Locate 2 , 1
      Lcd "        "                                        'smazn zobrazen hodnoty (pepsn mezerami)
Return                                                      'nvrat z podprogramu

Rem *********************************************************************************************************

Rem trval pepnut na men napt (nap pi nastavovn)
Rem (stejn jako podprogram "Volty", ale b v nekonen smyce)

Volty2:

Do                                                          'zatek smyky men napt
      Start Adc
      Volt1 = Getadc(0)
      Stop Adc
      Volt2 = Volt1 * 0.02
      Volt = Str(volt2)
      Volt = Left(volt , 4)                                 've stejn jako v podprogramu "Volty"
      Locate 2 , 1
      Lcd "Ub=" ; Volt ; "V"
      Waitms 100                                            'ekn 100 milisekund
      Locate 2 , 1
      Lcd "        "
      If Pind.1 = 0 Then                                    'podmnka pro nvrat na men kmitotu (uzemnn pinu D.1)
      Waitms 100                                            'ekn 100 milisekund
      Cls                                                   'smazn displeje
      Return                                                'nvrat do men kmitotu
      End If                                                'konec podmnky
Loop                                                        'konec smyky men napt

Rem *********************************************************************************************************


Rem nastaven MF kmitotu po uzemn pinu C.5


Nastav_mf:
Mff = Mf                                                    ' peten hodnoty MF z EEprom a zobrazen
Cls
Cursor Off
Locate 1 , 1
Lcd "MF (IF)"
Locate 2 , 1
Gosub Zobraz_mf


Do                                                          'zatek smyky nastaven hodnoty MF

   Locate 2 , 1                                             'podmnka (uzemnn pinu C.2) pro uloen hodnoty MF do EEprom a nvrat...
   If Pinc.2 = 0 Then                                       '...do men kmitotu

   Mf = Mff                                                 'uloen
   Lcd "Ulozeno!"
   Wait 3                                                   'zobrazen "Ulozeno!" na dobu 6 sekund
   Locate 2 , 1
   Lcd "Saved ! "                                           'and english as well (we have enough space in memory)
   Wait 3
   Cls                                                      'smazn displeje
   Return                                                   'nvrat na men kmitotu
   End If

   If Pinc.4 = 0 Then                                       'pokud je uzemnn pin C.4, tak ...
   Mff = Mff + 100                                          '....zven hodnoty MF o 1khz
   Gosub Zobraz_mf
   End If

   If Pinc.3 = 0 Then                                       'pokud je uzemnn pin C.3, tak ...
   Mff = Mff - 100                                          '....snen hodnoty MF o 1khz
   Gosub Zobraz_mf
   End If

   If Pind.3 = 0 Then                                       'pokud je uzemnn pin D.3, tak ...
   Incr Mff                                                 '....zven hodnoty MF o 10hz
   Gosub Zobraz_mf
   End If

   If Pind.4 = 0 Then                                       'pokud je uzemnn pin D.4, tak ...
   Decr Mff                                                 '....snen hodnoty MF o 10hz
   Gosub Zobraz_mf
   End If

   Locate 2 , 1                                             'zobrazen hodnoty  (stle dokola ve smyce)
   Lcd "        "
   Locate 2 , 1
   Gosub Zobraz_mf
Loop

Rem zobrazen hodnoty nastaven MF pi kadm prchodu smykou

Zobraz_mf:
   Mfk = Str(mff)
   Mfk = Format(mfk , " 0000.00")
   Lcd Mfk                                                  'zobrazen hodnoty
   Waitms 50
   Return

End                                                         'konec programu

Rem **************************  K A N  C   F I L M A  ************  T H E   E N D  **********************